<template>
  <li class="dept-tree-select">

    <!--打开的箭头-->
    <a class="icon-open tree-height" @click="onToggleClick(node)">
      <template v-if="node.hasChilds">
        <i class="fa fa-angle-right" aria-hidden="true" v-show="!this.loaded"></i>
        <i class="fa fa-angle-down" aria-hidden="true" v-show="this.loaded"></i>
      </template>

      <!--树形视图判断箭头符号-->
      <template v-if="isTreeView">
        <i class="fa fa-angle-right" aria-hidden="true" v-show="node.children && !this.loaded"></i>
        <i class="fa fa-angle-down" aria-hidden="true" v-show="node.children && this.loaded"></i>
      </template>
    </a>

    <!--选择的按钮-->
    <label class="mint-checklist-label view-li-leftLabel tree-height">
      <!--当为用户选择框时的加减符号-->
      <span v-if="userSelectionBox">
        <template v-if="node.userCount!=0">
        <span  class="fa fa-plus more" @click="showUsers(node.key)" v-show="!currentKey">
        </span>
        </template>
        <span class="box" v-else></span>
        <span  class="fa fa-minus more" @click="hideUsers(node.key)" v-show="currentKey">
        </span>
      </span>

      <!--当为树形视图_链接视图在视图选择框页面展示数据时-->
      <span  v-if="isView">
        <span class="mint-checkbox" v-if="mutil || selectOne">
          <input 
            type="checkbox"
            class="mint-checkbox-input"  
            :value="node.key"
            v-model="treeCheckVal"
            @change="onTreeCkeckValChange($event,node)"
          />
          <span class="mint-checkbox-core"></span>
        </span>
        <span class="mint-radio" v-else>
          <input 
            type="radio" 
            class="mint-radio-input" 
            :value="node.key"
            v-model="treeRadioVal"
            @change="onTreeRadioValChange($event,node)"
          /> 
          <span class="mint-radio-core"></span>
        </span> 
      </span>
      
      <!--当不是用户选择框或不是树形视图时为-->
      <span class="mint-checkbox" v-if="!userSelectionBox && !isTreeView">
        <span class="mint-radio" v-if="limit == '1'">
          <input 
            type="radio" 
            class="mint-radio-input" 
            :value="node.key"
            v-model="treeRadioVal"
            @change="onTreeRadioValChange($event,node)"
          /> 
          <span class="mint-radio-core"></span>
        </span>
        <span v-else>
          <input 
            type="checkbox"
            class="mint-checkbox-input"  
            :value="node.key" 
            v-model="selectedKeys" 
            @change="onChange($event,node, selectedKeys)"
          />
          <span class="mint-checkbox-core"></span>
        </span> 
      </span>

      <!--当是树形视图_链接表单时，显示选择按钮 -->
      <span class="mint-checkbox" v-if="innerType=='FORM' && !node.children && !isView">
        <input 
          type="checkbox"
          class="mint-checkbox-input"  
          :value="node.key" 
          v-model="selectedKeys"
          @change="treeViewFormHandle($event, node, selectedKeys)"
        />
        <span class="mint-checkbox-core"></span>
      </span>
    </label>

    <!--内容-->
    <span class="icon" @click="treeViewList(node, node.key)">
      <!--当不是树形视图的时候显示文件图标-->
      <div v-if="!isTreeView">
        <i class="fa fa-folder"></i>
      </div>
      <div class="dept-name" >
        {{node.label}}
      </div>
    </span>

    <div style="width:100%;background:#efeffa;height:1px;"></div>

    <!--当为用户选择框时，显示用户时-->
    <span v-if="currentKey && currentKey == node.key" class="user-box">
      <div class="user-list" v-for="(item, index) in userlists" :key="index">
        <span v-if="selectMode == 'multiSelect'">
          <label class="mint-checklist-label view-li-leftLabel">
            <span class="mint-checkbox">
              <input 
                type="checkbox"
                class="mint-checkbox-input"  
                :value="item.id" 
                v-model="selectedUserId" 
                @change="handleSelectedUser($event, item, node.key)"
              />
              <span class="mint-checkbox-core"></span>
            </span>
          </label>
        </span>
        <span v-if="selectMode == 'selectOne'">
          <label class="mint-radiolist-label view-li-leftLabel">
            <span class="mint-radio">
              <input 
                type="radio"
                class="mint-radio-input"  
                :value="item.id" 
                v-model="selectedUserId" 
                @change="handleSelectedUser($event, item, node.key)"
              />
              <span class="mint-radio-core"></span>
            </span>
          </label>
        </span>
        <span class="photo">
          <img v-if="!item.photo" src="../assets/images/face.jpg" alt="">
          <img v-else :src="item.photo" alt="">
        </span>
        <span class="name">
          {{item.name}}
        </span>
      </div>
    </span>
    
    <template v-if="this.loaded">
      <ul class="dept-tree-select">
        <comm-tree
          v-for="(node,index) in subnodes"
          :key="index"
          v-bind="$attrs"
          v-on="$listeners"
          :load="load"
          :newSelectedDept="newSelectedDept"
          :node="node"
          :props="isTreeView?{label:'label'}:{label:'name'}"
          :userSelectionBox = "userSelectionBox"
          :isTreeView="isTreeView"
          :viewId="viewId"
          :selectMode="selectMode"
          :saveStatusVal="saveStatusVal"
          :isView="isView"       
          :mutil="mutil"
          :selectOne="selectOne"
          :newTreeRadioVal = "newTreeRadioVal"
          :innerType = "innerType"
          :keepSelectionData = "keepSelectionData"
          :remainingUsers = "remainingUsers"
          :revisedDept = "revisedDept"
          :limit="limit"
        >
        </comm-tree>
      </ul>
    </template>
    <template>

    <!--树形视图弹出框 -->
    <comm_dialog 
      :title="$t('select_dept')" 
      :visible.sync="dialogVisible"  
      position="right"
      style="height: 100%;"
      class="dept-tree">
        <view_delegate
          :openParams="params"
          :parentId="parentId"
          v-if="dialogVisible"
          v-bind="$attrs"
          v-on="$listeners"
          ref="viewcomp"
        />
    </comm_dialog>
    </template>
  </li>
</template>

<script>
import comm_dialog from "@/components/comm_dialog.vue"
import view_delegate from "@/components/view_delegate.vue";
// import { Indicator } from "mint-ui";
export default {
  name: "comm-tree",
  props: [
    "props", 
    "load", 
    "node",
    "userSelectionBox",
    "newSelectedDept", 
    "isTreeView", //判断是否是树形视图
    'viewId', 
    "selectMode",
    "saveStatusVal", //树形部门选中部门后的回选状态
    "isView", //判断是否是视图选择框
    "mutil",  //视图选择框时多选
    "selectOne", //视图选择框时单选
    "selectedTreeviewId",
    "newTreeRadioVal", //树形视图单选时选中的值
    "innerType",  //树形视图判断是链接视图还是链接表单
    "keepSelectionData", //用户选择框控件保持选中的状态
    "remainingUsers",
    "revisedDept", //部门选择框修改后的部门
    "limit"
  ],
  components: {comm_dialog, view_delegate},
  inject: ['limitOne'], //树形部门选择框限制选择一个数据时

  data: function() {
    return {
      selectedKeys: [],
      loaded: false,
      subnodes: [] ,//格式为[{level:0, key:123, label:总部, isLeaf:false}]
      selectedDept:[],//选中的部门
      currentKey:'',
      selectedUserId:[],
      selectedUserRow:[],
      userlists:[],
      dialogVisible:false,
      params:{},
      parentId:'',
      hasChilds:[],
      userCount:'',
      treeRadioVal:'',//视图选择框时树形视图单选值
      treeCheckVal:[],//视图选择框时树形视图多选值
    };
  },

  watch: {
    newTreeRadioVal() {
      this.treeRadioVal = this.newTreeRadioVal
    },
    selectedKeys(val){
      this.$emit("update:selected", val);
    },
    newSelectedDept() {
      this.selectedKeys=[];
      for(let i=0; i<this.newSelectedDept.length; i++) {
        this.selectedKeys.push(this.newSelectedDept[i].key);
      }
    },
    remainingUsers() {
      this.selectedUserId = [];
      if(this.remainingUsers.length > 0) {
        for(let i = 0; i < this.remainingUsers.length; i++) {
          this.selectedUserId.push(this.remainingUsers[i].id);
        }
        this.$emit("setuserList",this.remainingUsers); //调用o_user_select的newUserList()方法
      }else {
        this.selectedUserId = [];
      }
    },
    revisedDept() {
      this.selectedKeys=[];
      for(let i=0; i<this.revisedDept.length; i++) {
        this.selectedKeys.push(this.revisedDept[i].key);
      }
      let del = "THREE";
      this.$emit('selectedVal',this.revisedDept,del);
    },
    'limitOne.treeDeptlimitOne': {
      deep:true,
      handler:function(newVal){
        this.treeRadioVal = newVal
      }
    }
  },

  beforeCreate() {
    this.$options.components.view_delegate = require('@/components/view_delegate.vue').default
  },

  created() {
    // this.loadNodeData({ key: "", level: 0, label: "总部" });
  },

  mounted() {
    this.setSelectedKeys(); //树形部门选择框回选
    this.setSelectionData(); //用户选择框控件已选中的用户
  },

  methods: {
    setSelectionData() {
      if(this.keepSelectionData && this.keepSelectionData.length > 0) {
        if(this.selectMode == 'selectOne') {
          this.selectedUserId = this.keepSelectionData[0].id //单选框回选只能用字符串
        }else {
          for(let i=0; i<this.keepSelectionData.length; i++) {
            this.selectedUserId.push(this.keepSelectionData[i].id);
          }
        }
        let onHold = "YES";
        this.$emit("action",this.keepSelectionData, '', '', onHold); //调用o_user_select的getUserData()方法
      }
    },

    //树形视图链接表单选值
    treeViewFormHandle(ev, node) {
      // this.$emit("treeViewAction", this.selectedKeys);
      let selected;
      if(ev.target.checked) {
        selected = "YES"
        this.$emit("treeViewAction",node.key, selected);  //调用view_treeview组件的treeViewSelectId()方法
      }else {
        selected = "NO"
        this.$emit("treeViewAction",node.key, selected); 
      }
      
    },

    onTreeRadioValChange(ev, node) {
      this.$emit('event',this.treeRadioVal, node)
    },

    setSelectedKeys(){
      if(this.saveStatusVal!=undefined){
        for(let i=0; i<this.saveStatusVal.length; i++) {
          this.selectedKeys.push(this.saveStatusVal[i].key);
        }
      }
      let del = "THREE";
      this.$emit('selectedVal',this.saveStatusVal,del);
    },

    treeViewList(node, key) {
      if(!this.isView) {
        if(this.isTreeView) {
          if(this.innerType == "VIEW") {
            let view = 'VIEW';
            this.$emit("jumpToForm", node, view);
          }else if(this.innerType == "FORM") {
            let form = 'FORM';
            this.$emit("jumpToForm", node, form);
          }else if(this.innerType == "LINK"){
            let form = 'LINK';
            this.$emit("jumpToForm", node, form);
          }
        }
      }
    },

    //用户选择框选择用户时
    handleSelectedUser(ev, item) { 
      if(this.selectMode == "selectOne"){
        let selectUser = [];
        let addRole = true
        selectUser.push(item);
        this.selectedUserRow = selectUser;
        this.$emit("action",this.selectedUserRow, addRole, this.selectMode);//调用o_user_select的getUserData()方法
      }else if(this.selectMode == "multiSelect"){
        if(ev.target.checked) { 
          let addRole = true
          //this.selectedUserRow.push(item)
          this.$emit("action",item, addRole, this.selectMode);
        }else {
          let addRole = false
          this.$emit("action",item, addRole, this.selectMode);
        }
      }
    },

    hideUsers() {
      this.currentKey = '';
    },

    showUsers(key){
      let appId = this.$root.appid;
      let deptId = key;
      let pageSize = 9999;
      let pageNum = 1;
      this.$api.departmentPage(appId, deptId, pageNum, pageSize, {
        onSucess: response => {
          let data = response.data.data.datas;
          let obj = [];
          data.forEach(item => {
            if(item.type == 1) {
              obj.push(item);
            }
          });
          this.userlists = obj;
          this.userlists.forEach((item,index) => {
            this.$api.getAvatar(item.id, {
              onSucess: response => {
                this.userlists[index].photo = response.data.data;
                this.$forceUpdate();
              }
            })
          });
        }
      });
      this.currentKey = key
    },
    
    //树形视图选中的值
    onTreeCkeckValChange(ev, node){
      let selected;
      if(ev.target.checked) {
        selected = "YES"
        this.$emit("action",node.key, selected);  //调用view_treeview组件的getCheckVal()方法
      }else {
        selected = "NO"
        this.$emit("action",node.key, selected); 
      }
    },

    //当改变时，触发树形部门选择框的方法
    onChange(ev, node, selectedKeys) { 
      let del;
      if(ev.target.checked) {
        for(let i=0; i<selectedKeys.length; i++) {
          if(node.key && selectedKeys[i] == node.key) {
            this.selectedDept.push(node);
          }
        }
        del = "FIRST";
        this.$emit('selectedVal',this.selectedDept,del);  //调用父组件的getSelectedData()方法
      }else {
        let arr = [];
        arr.push(node);
        del = "SECOND";
        this.$emit('selectedVal', arr, del);
      }
    },

    onToggleClick(node) {
      if (!this.loaded) {
        this.loadNodeData(node);
      }else{
        this.hideloadNodeData();
      }
    },

    hideloadNodeData() {
      this.loaded = false;
      this.node.loaded = false;
    },

    loadNodeData(node) {
      let nn = node;
      let nodekey = this.$attrs["node-key"];
      let label = this.props.label;
      this.load(node, data => {
        if(this.subnodes.length != 0){
          if(this.subnodes[0].key == data[0].id){
            this.loaded = true;
            this.node.loaded = true;
            return false;
          }else{
            if(this.isTreeView) {
              data.forEach(elm => {
                for(let i=0; i<this.subnodes.length; i++) {
                  if(elm.key == this.subnodes[i].key) {
                    this.subnodes.splice(i,1);
                    i--
                  }
                }
                let n = {
                  level: nn.level + 1,
                  key: elm[nodekey],
                  label: elm[label],
                  loaded: false,
                  hasChilds:elm.hasChilds,
                  userCount:elm.userCount,
                };
                this.subnodes.push(n);
                this.loaded = true;
                this.hasChilds.push(n.hasChilds);
              })

            }else {
              data.forEach(elm => {
                let n = {
                  level: nn.level + 1,
                  key: elm[nodekey],
                  label: elm[label],
                  loaded: false,
                  hasChilds: elm.hasChilds,
                  userCount: elm.userCount,
                  children: elm.children, //判断树形视图是否有下级节点
                  formId: elm.formId  //树形视图需要的formId
                };
                this.subnodes.push(n);
                this.loaded = true;
                this.hasChilds.push(n.hasChilds);
              });
            }
          }
        }else{
          data.forEach(elm => {
            let n = {
              level: nn.level + 1,
              key: elm[nodekey],
              label: elm[label],
              loaded: false,
              hasChilds: elm.hasChilds,
              userCount: elm.userCount,
              children: elm.children, //判断树形视图是否有下级节点
              formId: elm.formId  //树形视图需要的formId
            };
            this.subnodes.push(n);
            this.loaded = true;
            this.hasChilds.push(n.hasChilds);
          });
        }
      });
      this.node.loaded = true;
    }
  }
};
</script>